-- About.lua
-- Written by Habna


function frmSwappable()
	self = Turbine.UI.Lotro.Window();
	--self = Turbine.UI.Lotro.GoldWindow();
	
	self:SetSize( 450, 500 );
	local screenWidth, screenHeight = Turbine.UI.Display.GetSize();
	local winWidth, winHeight = self:GetSize();
	local left, top = ( screenWidth / 2 ) - ( winWidth / 2 ) , ( screenHeight / 2 ) - ( winHeight / 2 );
    self:SetPosition( left, top );
	self:SetText( "Add/Remove Swappable Item" );
	self:SetVisible( true );
	self:SetZOrder( 2 );

	self.MouseDown = function( sender, args )
		if ( args.Button == Turbine.UI.MouseButton.Left ) then
			if ( args.X < 23 and args.Y > 15 and args.Y < 50 )then
				-- TopLeft

			elseif ( ( args.X < 23 ) and ( args.Y > ( self:GetHeight() - 30 ) ) ) then
				-- BottomLeft

			elseif ( args.X > ( self:GetWidth() -30 ) ) and ( args.Y > ( self:GetHeight() - 30 ) ) then
				-- BottomRight
				--CornerClick = "BottomRight";
			end
			--dragStartX = args.X;
			--dragging = true;
		end
	end
	
	self.MouseUp = function( sender, args )
		dragging = false;
		CornerClick = "";
	end

	self.MouseMove = function( sender, args )
		if ( dragging ) then
			--self.MouseLeave( sender, args );

			tCatWidth, tCatWinHeight = self:GetSize();
			local tempX = tCatWidth + ( args.X - dragStartX );
			
			if CornerClick == "BottomRight" then
				if ( self:GetWidth() < 400 ) then
					self:SetSize( 400, tCatWinHeight );
					dragging = false;
				else
					self:SetSize( tempX, tCatWinHeight );
					dragStartX = dragStartX + (args.X - dragStartX);
				end
			elseif CornerClick == "BottomLeft" then
				
			end

			PerformLayout();
		else
			if ( args.X < 23 and args.Y > 15 and args.Y < 50 )then
				-- "TopLeft"
					
			elseif ( ( args.X < 23 ) and ( args.Y > ( self:GetHeight() - 30 ) ) ) then
				-- "BottomLeft"
					
			elseif ( args.X > ( self:GetWidth() - 30 ) ) and ( args.Y > ( self:GetHeight() - 30 ) ) then
				-- "BottomRight"
				--ShowResizeCursor();
			--else
				--self.MouseLeave( sender, args );
			end
		end
	end

	self.MouseLeave = function( sender, args )
		if self.cursor ~= nil then
			self.cursor:SetVisible( false );
			self.cursor = nil;
		end
	end

	lblBackPack = Turbine.UI.Label();
	lblBackPack:SetParent( self );
	lblBackPack:SetText( "Please select an item from the list box below to be added/removed from the swappable items list. Number in bracket is the item category." );
	lblBackPack:SetPosition( 15, 35);
	lblBackPack:SetSize( self:GetWidth() - 50 , 35 );
	lblBackPack:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	lblBackPack:SetForeColor( green );

	ListBoxBorder = Turbine.UI.Control();
	ListBoxBorder:SetParent( self );

	ListBox = Turbine.UI.ListBox();
	ListBox:SetParent( self );
	ListBox:SetPosition( 15, lblBackPack:GetHeight() + 40 );
	ListBox:SetSize( self:GetWidth() - 40, 250 );
	ListBox:SetMaxItemsPerLine( 2 );
	ListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	ListBox:SetBackColor( black );
	
	ListBoxBorder:SetPosition( 13, ListBox:GetTop() - 2 );
	ListBoxBorder:SetSize( ListBox:GetWidth() + 4, ListBox:GetHeight() + 4 );
	ListBoxBorder:SetBackColor( grey );
	ListBoxBorder:SetVisible( true );

	ScrollBar = Turbine.UI.Lotro.ScrollBar();
	ScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
	ScrollBar:SetParent( self );
	ScrollBar:SetPosition( self:GetWidth() - 20, ListBox:GetTop() );
	ScrollBar:SetHeight( ListBox:GetHeight() );
	ScrollBar:SetWidth( 10 );
	ListBox:SetVerticalScrollBar( ScrollBar );

	lblLoadedCat = Turbine.UI.Label();
	lblLoadedCat:SetParent( self );
	lblLoadedCat:SetText( "List of already loaded category:" );
	lblLoadedCat:SetPosition( 15, ListBox:GetTop() + ListBox:GetHeight() + 5);
	lblLoadedCat:SetSize( self:GetWidth() - 50 , 12 );
	lblLoadedCat:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	lblLoadedCat:SetForeColor( green );
	
	lblLCatBorder = Turbine.UI.Label();
	lblLCatBorder:SetParent( self );

	lblLCat = Turbine.UI.Label();
	lblLCat:SetParent( self );
	lblLCat:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
	lblLCat:SetPosition( 15, lblLoadedCat:GetTop() + lblLoadedCat:GetHeight() + 5 );
	lblLCat:SetSize( ListBox:GetWidth() , 40 );
	lblLCat:SetBackColor( black );
	lblLCat:SetTextAlignment( Turbine.UI.ContentAlignment.TopLeft );
	lblLCat:SetForeColor( white );

	lblLCatBorder:SetPosition( 13, lblLCat:GetTop() - 2 );
	lblLCatBorder:SetSize( lblLCat:GetWidth() + 4, lblLCat:GetHeight() + 4 );
	lblLCatBorder:SetBackColor( grey );

	lblSelect = Turbine.UI.Label();
	lblSelect:SetParent( self );
	lblSelect:SetText( "Selected item from the items list box:" );
	lblSelect:SetPosition( 15, lblLCatBorder:GetTop() + lblLCatBorder:GetHeight() + 5 );
	lblSelect:SetSize( ListBox:GetWidth(), 12 );
	lblSelect:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	lblSelect:SetForeColor( green );

	lblSelectedItem = Turbine.UI.Label();
	lblSelectedItem:SetParent( self );
	lblSelectedItem:SetText( "Please select an item in the items list box" );
	lblSelectedItem:SetPosition( 15, lblSelect:GetTop() + lblSelect:GetHeight() + 5 );
	lblSelectedItem:SetSize( ListBox:GetWidth(), 20 );
	lblSelectedItem:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
	lblSelectedItem:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	lblSelectedItem:SetForeColor( white );

	buttonAdd = Turbine.UI.Lotro.Button();
	buttonAdd:SetParent( self );
	buttonAdd:SetSize( 100, 15 );
	buttonAdd:SetPosition( (self:GetWidth() / 4) - (buttonAdd:GetWidth() / 2), lblSelectedItem:GetTop() + lblSelectedItem:GetHeight() + 5 );
	buttonAdd:SetText( "Add to list" );
	buttonAdd:SetVisible( true );
	buttonAdd:SetEnabled( false );

	buttonAdd.Click = function( sender, args )
		table.insert( tCat, SelCat );  -- table.insert( table, value);
		table.sort( tCat );
		write("HugeBag: Item category " .. SelCat .. " added successfully." );
		lblLCat:SetText( " " .. table.concat( tCat, ", " ) );
		lblMessage:SetVisible( false );
		buttonAdd:SetEnabled( false );
		BPItem[PrevItemClic]:SetBackColor( none );
		BPItem[PrevItemClic].Sel = false;
		PrevItemClic = 0;
		SaveSwappableSettings();
	end

	buttonRemove = Turbine.UI.Lotro.Button();
	buttonRemove:SetParent( self );
	buttonRemove:SetSize( 130, 15 );
	buttonRemove:SetPosition( ((self:GetWidth() / 4) * 3) - (buttonRemove:GetWidth() / 2), buttonAdd:GetTop() );
	buttonRemove:SetText( "Remove from list" );
	buttonRemove:SetVisible( true );
	buttonRemove:SetEnabled( false );

	buttonRemove.Click = function( sender, args )
		table.remove( tCat, ItemKey );
		write("HugeBag: Item category " .. SelCat .. " removed successfully." );
		lblLCat:SetText( " " .. table.concat( tCat, ", " ) );
		lblMessage:SetVisible( false );
		buttonRemove:SetEnabled( false );
		BPItem[PrevItemClic]:SetBackColor( none );
		BPItem[PrevItemClic].Sel = false;
		PrevItemClic = 0;
		SaveSwappableSettings();
	end

	lblMessage = Turbine.UI.Label();
	lblMessage:SetParent( self );
	lblMessage:SetPosition( 20, buttonRemove:GetTop() + buttonRemove:GetHeight() + 2 );
	lblMessage:SetSize( self:GetWidth() - 40, 30 );
	lblMessage:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
	lblMessage:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	
	RefreshBackPack();
	lblLCat:SetText( " " .. table.concat( tCat, ", " ) );
end

function RefreshBackPack()
	local player = Turbine.Gameplay.LocalPlayer.GetInstance();
	local backpack = player:GetBackpack();
	local size = backpack:GetSize();
	PrevItemClic = 0;
	SelCat = 0;
	
	BPItem = {};
	ListBox:ClearItems();
	
	for i = 1, size do
		item = backpack:GetItem( i );
		if item ~= nil then
			BPItem[i] = Turbine.UI.Label();
			BPItem[i]:SetParent( itemsCtl );
			BPItem[i]:SetSize( ListBox:GetWidth() - 35, 35 );
			BPItem[i]:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
			BPItem[i]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
			BPItem[i]:SetForeColor( white );
			BPItem[i].id = i;
			BPItem[i].Name = item:GetName();
			BPItem[i].Cat = item:GetCategory();
			BPItem[i].Sel = false; -- To know if item was selected by user clicking it
			BPItem[i].Item = Turbine.UI.Lotro.ItemControl( backpack:GetItem( i ) );
			BPItem[i]:SetText( " (" .. BPItem[i].Cat .. ") " .. BPItem[i].Name );
			ListBox:AddItem( BPItem[i].Item );
			ListBox:AddItem( BPItem[i] );

			BPItem[i].MouseClick = function(sender, args)
				if PrevItemClic ~= 0 then
					BPItem[PrevItemClic]:SetBackColor( none );
					BPItem[PrevItemClic].Sel = false;
				end
				PrevItemClic = BPItem[i].id;
				SelCat = BPItem[i].Cat;
				BPItem[i].Sel = true;
				lblSelectedItem:SetText( BPItem[i]:GetText() );
				bFound = isInArray(tCat, BPItem[i].Cat);
				lblMessage:SetVisible( true );
				if bFound then
					lblMessage:SetForeColor( red );
					lblMessage:SetText( "This category is already in the list." );
					buttonAdd:SetEnabled( false );
					buttonRemove:SetEnabled( true );
				else
					lblMessage:SetForeColor( green );
					lblMessage:SetText( "This item can be added if it's a swappable item." );
					buttonAdd:SetEnabled( true );
					buttonRemove:SetEnabled( false );
				end
			end

			BPItem[i].MouseHover = function(sender, args)
				BPItem[i]:SetForeColor( black );
				BPItem[i]:SetBackColor( rustedgold );
				BPItem[i]:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
			end

			BPItem[i].MouseLeave = function(sender, args)
				BPItem[i]:SetBackColor( none );
				if BPItem[i].Sel then BPItem[i]:SetBackColor( blue ); end
				BPItem[i]:SetForeColor( white );
			end
		end
	end
end

function PerformLayout()
	lblBackPack:SetSize( self:GetWidth() - 50 , 35 );
	ListBox:SetSize( self:GetWidth() - 40, 250 );
	ListBoxBorder:SetSize( ListBox:GetWidth() + 4, ListBox:GetHeight() + 4 );
	ScrollBar:SetPosition( self:GetWidth() - 20, ListBox:GetTop() );
	lblLoadedCat:SetSize( self:GetWidth() - 50 , 12 );
	lblLCat:SetSize( ListBox:GetWidth() , 40 );
	lblLCatBorder:SetSize( lblLCat:GetWidth() + 4, lblLCat:GetHeight() + 4 );
	lblSelect:SetSize( lblLCat:GetWidth(), 12 );
	lblSelectedItem:SetSize( lblLCat:GetWidth(), 20 );
	buttonAdd:SetPosition( (self:GetWidth() / 4) - (buttonAdd:GetWidth() / 2), lblSelectedItem:GetTop() + lblSelectedItem:GetHeight() + 5 );
	buttonRemove:SetPosition( ((self:GetWidth() / 4) * 3) - (buttonRemove:GetWidth() / 2), buttonAdd:GetTop() );
	lblMessage:SetSize( self:GetWidth() - 40, 30 );
	RefreshBackPack();
	lblLCat:SetText( " " .. table.concat( tCat, ", " ) );
end